# generated by datamodel-codegen:
#   filename:  schema/entity/services/connections/database/db2Connection.json
#   timestamp: 2022-04-05T19:51:47+00:00

from __future__ import annotations

from enum import Enum
from typing import List, Optional

from pydantic import BaseModel, Extra, Field, SecretStr

from . import connectionBasicType


class SupportedPipelineType12(Enum):
    Metadata = 'Metadata'


class Db2Type(Enum):
    Db2 = 'Db2'


class Db2Scheme(Enum):
    db2_ibm_db = 'db2+ibm_db'


class DB2Connection(BaseModel):
    class Config:
        extra = Extra.forbid

    type: Optional[Db2Type] = Field('Db2', description='Service Type')
    scheme: Optional[Db2Scheme] = Field(
        'db2+ibm_db', description='SQLAlchemy driver scheme options.'
    )
    username: Optional[str] = Field(
        None,
        description='username to connect  to the DB2. This user should have privileges to read all the metadata in DB2.',
    )
    password: Optional[SecretStr] = Field(
        None, description='password to connect to the DB2.'
    )
    hostPort: Optional[str] = Field(None, description='Host and port of the DB2')
    database: Optional[str] = Field(
        None,
        description='Database of the data source. This is optional parameter, if you would like to restrict the metadata reading to a single database. When left blank , OpenMetadata Ingestion attempts to scan all the databases in DB2.',
    )
    connectionOptions: Optional[connectionBasicType.ConnectionOptions] = None
    connectionArguments: Optional[connectionBasicType.ConnectionArguments] = None
    supportedPipelineTypes: Optional[List[SupportedPipelineType12]] = Field(
        ['Metadata'], description='Supported Metadata Extraction Pipelines.'
    )
